using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using Microsoft.Win32;
using System.IO.Ports;
using System.Text.RegularExpressions;
using System.Threading;
using System.IO;
using System.Diagnostics;

namespace ZKC.WincePrinter
{
    public partial class Form1 : Form
    {
        ///string kldPath = "\\Storage Card\\NaviOne\\NaviOne.exe";
        string kldPath = "\\Storage Card\\NaviOne.exe";
        SerialPort serialPort1 = null;
        ///private System.Windows.Forms.PictureBox pictureBox1;
        ///
        bool isOpen = false;
        public Form1()
        {
            InitializeComponent();
            this.Size = new Size(Screen.PrimaryScreen.Bounds.Width, Screen.PrimaryScreen.Bounds.Height);
        }
        private void Form1_Load(object sender, EventArgs e)
        {
            try
            {
                //if (File.Exists(kldPath))
                //{
                //    Process.Start(kldPath, "");
                //}
                //else
                //{
                //    textBox2.Text = "δֵͼ";
                //}
                timer1.Enabled = true;
                //string CodePath = System.Reflection.Assembly.GetExecutingAssembly().GetName().CodeBase;
                ////using (RegistryKey key = Registry.LocalMachine.OpenSubKey("init", true))
                ////{
                ////    key.SetValue("Launch50", CodePath);
                ////}

            }
            catch (Exception ex)
            {
                textBox2.Text = ex.Message;
            }

        }
        // ȶһί
        public delegate void SetTextCallback(string text);
        string ss = "";
        private void serialReceived(object sender, System.IO.Ports.SerialDataReceivedEventArgs e)
        {
            try
            {
                byte[] serialdata = new byte[serialPort1.BytesToRead];
                serialPort1.Read(serialdata, 0, serialdata.Length);
                ss += System.Text.Encoding.Default.GetString(serialdata, 0, serialdata.Length);
                if (ss.IndexOf("\r\n") > 0)
                {
                    setText(ss);
                }
            }
            catch (Exception ex)
            {
                textBox2.Text = ex.Message;
            }
        }
        // ı
        private void setText(string text)
        {
            if (textBox1.InvokeRequired)
            {
                SetTextCallback s = new SetTextCallback(setText);
                Invoke(s, new string[] { text });
            }
            else
            {
                if (textBox1.Text.Length > 500)
                {
                    textBox1.Text = "";
                }

                if (text.IndexOf("+RTINQ=") >= 0)
                {
                    string pattern = @"(?<=;)(.*?)(?=\r\n)";
                    Regex regex = new Regex(pattern, RegexOptions.Singleline);
                    deviceStr.Clear();
                    foreach (Match m in regex.Matches(text))
                    {
                        deviceStr.Add(m.Value);
                    }

                    string patternAdr = @"(?<=RTINQ=)(.*?)(?=;)";
                    Regex regexAdr = new Regex(patternAdr, RegexOptions.Singleline);
                    deviceAdr.Clear();
                    foreach (Match m in regexAdr.Matches(text))
                    {
                        deviceAdr.Add(m.Value);
                    }
                }

                textBox1.Text = text;
            }
        }

        List<string> deviceStr = new List<string>();
        List<string> deviceAdr = new List<string>();

        private void button1_Click(object sender, EventArgs e)
        {
            try
            {
                serialPort1.Write("\r\n+STWMOD=0\r\n");
            }
            catch (Exception ex)
            {
                textBox2.Text = ex.Message;
            }
        }

        private void button2_Click(object sender, EventArgs e)
        {
            try
            {
                serialPort1.Write("\r\n+STWMOD=1\r\n");
            }
            catch (Exception ex)
            {
                textBox2.Text = ex.Message;
            }
        }

        private void Form1_Closing(object sender, CancelEventArgs e)
        {
            if (isOpen)
            {
                if (serialPort1.IsOpen)
                {
                    serialPort1.Close();
                }
            }
            timer1.Enabled = false;
        }

        private void button3_Click(object sender, EventArgs e)
        {
            try
            {
                serialPort1.Write("\r\n+INQ=0\r\n");
            }
            catch (Exception ex)
            {
                textBox2.Text = ex.Message;
            }
        }

        //ʼ
        private void button4_Click(object sender, EventArgs e)
        {
            try
            {
                if (serialPort1 != null)
                {
                    ss = "";
                    serialPort1.Write("\r\n+INQ=1\r\n");

                    textBox2.Text = "...";
                }
                else
                {
                    textBox2.Text = "ѡ񴮿ڲ򿪣";
                }
            }
            catch (Exception ex)
            {
                textBox2.Text = ex.Message;
            }
        }

        private void textBox1_TextChanged(object sender, EventArgs e)
        {
            textBox1.SelectionStart = textBox1.Text.Length;

            textBox1.ScrollToCaret();
        }

        //
        private void button5_Click(object sender, EventArgs e)
        {
            try
            {
                if (serialPort1 != null)
                {
                    string txtStr = textBox2.Text.Trim();
                    serialPort1.Write("\r\n+CONN=" + txtStr + "\r\n");
                    textBox2.Text = "У";
                }
                else
                {
                    textBox2.Text = "ѡ񴮿ڲ򿪣";
                }
            }
            catch (Exception ex)
            {
                textBox2.Text = ex.Message;
            }
        }

        //PIN
        private void button6_Click(object sender, EventArgs e)
        {
            try
            {
                if (textBox3.Text.Trim() == "88")
                {
                    Process.Start("explorer.exe","");
                    Thread.Sleep(1000);
                    Application.Exit();
                }
                if (serialPort1 != null)
                {
                    string pin = textBox3.Text.Trim();
                    serialPort1.Write("\r\n+STPIN=" + pin + "\r\n");
                }
                else
                {
                    textBox2.Text = "ѡ񴮿ڲ򿪣";
                }
            }
            catch (Exception ex)
            {
                textBox2.Text = ex.Message;
            }
        }

        int index = 0;
        private void timer1_Tick(object sender, EventArgs e)
        {
            this.Text = deviceStr.Count.ToString();
            if (deviceStr.Count > 0)
            {
                comboBox1.Items.Clear();
                for (int i = 0; i < deviceStr.Count; i++)
                {
                    comboBox1.Items.Add(deviceStr[i]);
                }
                textBox2.Text = "," + deviceStr.Count+"豸";
            }
            deviceStr.Clear();
            index++;
            ////if (index > 10)
            ////{
            ////    this.pictureBox1.Visible = false;
            ////}
        }

        private void comboBox1_SelectedIndexChanged(object sender, EventArgs e)
        {
            try
            {
                if (comboBox1.SelectedIndex >= 0)
                {
                    textBox2.Text = deviceAdr[comboBox1.SelectedIndex];
                }
            }
            catch (Exception ex)
            {
                textBox2.Text = ex.Message;
            }
        }

        private void button1_Click_1(object sender, EventArgs e)
        {
            try
            {
                if (comboBox2.Text != "")
                {
                    if (button1.Text == "")
                    {
                        isOpen = true;
                        button1.Text = "ر";
                        serialPort1 = new SerialPort(comboBox2.Text, 115200, Parity.None, 8, StopBits.One);
                        serialPort1.ReceivedBytesThreshold = 1;
                        serialPort1.DataReceived += new SerialDataReceivedEventHandler(serialReceived);
                        serialPort1.Open();

                        //serialPort1.Write("\r\n+STOAUT=1\r\n");
                        //serialPort1.Write("\r\n+STAUTO=1\r\n");
                        
                        textBox2.Text = "򿪳ɹ";
                    }
                    else
                    {
                        isOpen = false;
                        button1.Text = "";
                        serialPort1.Close();
                    }
                }
            }
            catch (Exception ex)
            {
                textBox2.Text = ex.Message;
            }
        }

        private void Form1_DoubleClick(object sender, EventArgs e)
        {
            ///Application.Exit();
        }

        private void button2_Click_1(object sender, EventArgs e)
        {
            try
            {
                if (isOpen)
                {
                    isOpen = false;
                    serialPort1.Close();
                    serialPort1 = null;
                    button1.Text = "";
                }
                if (File.Exists(kldPath))
                {
                    Process.Start(kldPath, "");
                }
            }
            catch (Exception ex)
            {
                textBox2.Text = ex.Message;
            }
        }

        private void textBox3_GotFocus(object sender, EventArgs e)
        {
            inputPanel1.Enabled = true;
        }

        private void textBox3_LostFocus(object sender, EventArgs e)
        {
            inputPanel1.Enabled = false;
        }

        private void button2_Click_2(object sender, EventArgs e)
        {
            Application.Exit();
        }

        private void textBox4_GotFocus(object sender, EventArgs e)
        {
            inputPanel1.Enabled = true;
        }


        private void button7_Click(object sender, EventArgs e)
        {
            inputPanel1.Enabled = false;
            Application.Exit();
        }

        //
        private void button9_Click(object sender, EventArgs e)
        {
            button4.Enabled = true;
            serialPort1.Write("\r\n+STWMOD=1\r\n");

            serialPort1.Write("\r\n+INQ=1\r\n");
        }

        //ͻ
        private void button8_Click(object sender, EventArgs e)
        {
            //button4.Enabled = false;
            serialPort1.Write("\r\n+STWMOD=0\r\n");

            serialPort1.Write("\r\n+INQ=1\r\n");


            serialPort1.Write("\r\n+STAUTO=1\r\n");//ÿɼ
        }

        private void button3_Click_2(object sender, EventArgs e)
        {
            //serialPort1.Write("0x1b");
            //serialPort1.Write("0x38");
            //serialPort1.Write("0x00");
            //serialPort1.Write(DateTime.Now.ToString("yyyy-MM-dd hh:mm:ss")+"ǹ޹˾ӡ\r\n");
            byte[] bt = System.Text.Encoding.Default.GetBytes(DateTime.Now.ToString("yyyy-MM-dd hh:mm:ss") + "ǹ޹˾ӡ\r\n");
            serialPort1.Write(bt, 0, bt.Length);
        }

        /// <summary>
        /// ַת16ֽ
        /// </summary>
        /// <param name="hexString"></param>
        /// <returns></returns>
        private static byte[] strToToHexByte(string hexString)
        {
            hexString = hexString.Replace(" ", "");
            if ((hexString.Length % 2) != 0)
                hexString += " ";
            byte[] returnBytes = new byte[hexString.Length / 2];
            for (int i = 0; i < returnBytes.Length; i++)
                returnBytes[i] = Convert.ToByte(hexString.Substring(i * 2, 2), 16);
            return returnBytes;
        }

        private void button10_Click(object sender, EventArgs e)
        {
            serialPort1.Write("\r\n+STAUTO=0\r\n");
        }

        private void button7_Click_1(object sender, EventArgs e)
        {
            serialPort1.Write("\r\n+STAUTO=1\r\n");
        }
    }
}